{
  description = "Overlay for Linux kernel with fanotify access controls enabled";

  inputs.nixpkgs.url = "github:NixOS/nixpkgs/nixos-unstable";

  outputs = { self, nixpkgs }: let
    pkgs = import nixpkgs { system = "x86_64-linux"; };
  in rec {
    packages.x86_64-linux = rec {
      default = linux-kernel-fanotify;
      linux-kernel-fanotify = pkgs.linuxPackages.kernel.override {
        extraConfig = ''
          FANOTIFY_ACCESS_PERMISSIONS y
        '';
      };
    };

    overlay = final: prev: {
      linuxPackages_fanotify = pkgs.linuxPackages // {
        kernel = packages.x86_64-linux.linux-kernel-fanotify;
      };
    };
  };
}
